double calc_prs(np_rgb rgb)
{
	int a = (77 * rgb.r + 150 * rgb.g + 29 * rgb.b) / 256;
	return 1.0 - a / 255.0;
	//return 1.0 - (rgb.r + rgb.g + rgb.b) / (255.0 * 3);
	
	//int prs = (1.0 - (rgb.r + rgb.g + rgb.b) / (255.0 * 3) ) * 8;
	//return prs / 8.0;
}


void draw_point_(np_image img,np_canvas c,int x,int y,int step0,int step)
{
	for (int i = 0; i < step0; i += step) 
	{
		np_rgb rgb1 = get_color(img,x + i,y + i);
		double prs1 = calc_prs(rgb1);
		np_rgb rgb2 = get_color(img,x + i + step,y + i + step);
		double prs2 = calc_prs(rgb2);
		np_point p1;
		p1.x = x + i;
		p1.y = y + i;
		np_point p2;
		p2.x = x + i + step;
		p2.y = y + i + step;
		draw_line_prs_(c,p1,prs1,p2,prs2);
	}
	
}


void draw_point_cross(np_image img,np_canvas c,int x,int y,int step0,int step)
{
	for (int i = 0; i < step0; i += step) 
	{
		int x1 = x + i;
		int y1 = y + i;
		np_rgb rgb1 = get_color(img,x1,y1);
		double prs1 = calc_prs(rgb1);
		np_rgb rgb2 = get_color(img,x1 + step,y1 + step);
		double prs2 = calc_prs(rgb2);
		np_point p1;
		p1.x = x1;
		p1.y = y1;
		np_point p2;
		p2.x = x1 + step;
		p2.y = y1 + step;
		draw_line_prs_(c,p1,prs1,p2,prs2);
	}
	
	for (int i2 = 0; i2 < step0; i2 += step) 
	{
		int x3 = x + step0 - i2;
		int y3 = y + i2;
		np_rgb rgb3 = get_color(img,x3,y3);
		double prs3 = calc_prs(rgb3);
		np_rgb rgb4 = get_color(img,x3 - step,y3 + step);
		double prs4 = calc_prs(rgb4);
		np_point p3;
		p3.x = x3;
		p3.y = y3;
		np_point p4;
		p4.x = x3 - step;
		p4.y = y3 + step;
		draw_line_prs_(c,p3,prs3,p4,prs4);
	}
	
}



void draw_point_cross2(np_image img,np_canvas c,int x,int y,int step0,int step)
{

	for (int i = 0; i < step0; i += step) 
	{
		int x1 = x + i;
		int y1 = y + i;
		np_rgb rgb1 = get_color(img,x1,y1);
		double prs1 = calc_prs(rgb1);
		np_rgb rgb2 = get_color(img,x1 + step,y1 + step);
		double prs2 = calc_prs(rgb2);
		np_point p1;
		p1.x = x1;
		p1.y = y1;
		np_point p2;
		p2.x = x1 + step;
		p2.y = y1 + step;
		draw_line_prs_(c,p1,prs1,p2,prs2);
	}
	for (int i2 = 0; i2 < step0; i2 += step) 
	{
		int x3 = x + step0 - i2;
		int y3 = y + i2;
		np_rgb rgb3 = get_color(img,x3,y3);
		double prs3 = calc_prs(rgb3);
		np_rgb rgb4 = get_color(img,x3 - step,y3 + step);
		double prs4 = calc_prs(rgb4);
		np_point p3;
		p3.x = x3;
		p3.y = y3;
		np_point p4;
		p4.x = x3 - step;
		p4.y = y3 + step;
		if (prs3 + prs4 > 1) {
			draw_line_prs_(c,p3,prs3,p4,prs4);
		}
	}
	
}



void draw_pen_cross2_(int step,int step2)
{

	np_canvas c = get_active_canvas();
	np_image img = get_active_image();
	int w = get_width(img);
	int h = get_height(img);
	
	begin_draw_line_(c);
	for (int j = 0; j < h; j += step) {
		for (int i = 0; i < w; i += step) {
			if (is_esc_pressed() ) {
				end_draw_line_(c);
				return;
			}
			draw_point_cross2(img,c,i,j,step,step2);

		}
		set_window_title(to_s(j)+ "/" + to_s(h) + " ESCŒf");
	}
	end_draw_line_(c);


}

void draw_pen_cross2(int step,int step2)
{
	np_cmd(NP_NEW_LAYER);
	set_opacity(get_active_layer(),0);
	
	draw_pen_cross2_(step,step2);
	
	set_opacity(get_active_layer(),255);

}



void draw_pen_cross_(int step,int step2)
{

	
	np_canvas c = get_active_canvas();
	np_image img = get_active_image();
	int w = get_width(img);
	int h = get_height(img);

	begin_draw_line_(c);
	for (int j = 0; j < h; j += step) {
		for (int i = 0; i < w; i += step) {
			if (is_esc_pressed() ) {
				end_draw_line_(c);
				return;
			}
			draw_point_cross2(img,c,i,j,step,step2);

		}
		set_window_title(to_s(j)+ "/" + to_s(h) + " ESCŒf");
	}
	end_draw_line_(c);

}



void draw_pen_cross(int step,int step2)
{
	np_cmd(NP_NEW_LAYER);
	set_opacity(get_active_layer(),0);

	draw_pen_cross_(step,step2);

	set_opacity(get_active_layer(),255);
}


void draw_pen_(int step,int step2)
{

	
	np_canvas c = get_active_canvas();
	np_image img = get_active_image();
	int w = get_width(img);
	int h = get_height(img);
	
	begin_draw_line_(c);
	for (int j = 0; j < h; j += step) {
		for (int i = 0; i < w; i += step) {
			if (is_esc_pressed() ) {
				end_draw_line_(c);
				return;
			}
			draw_point_(img,c,i,j,step,step2);

		}
		set_window_title(to_s(j)+ "/" + to_s(h) + " ESCŒf");
	}
	end_draw_line_(c);
	
}


void draw_pen(int step,int step2)
{
	np_cmd(NP_NEW_LAYER);
	set_opacity(get_active_layer(),0);
	
	draw_pen_(step,step2);
	
	set_opacity(get_active_layer(),255);
}


void draw_pen__4_1()
{
	draw_pen_(4,1);
}

void draw_pen_cross__4_1()
{
	draw_pen_cross_(4,1);
}

void draw_pen_cross2__4_1()
{
	draw_pen_cross2_(4,1);
}


void draw_pen_2_1()
{
	draw_pen(2,1);
}

void draw_pen_cross_2_1()
{
	draw_pen_cross(2,1);
}

void draw_pen_cross2_2_1()
{
	draw_pen_cross2(4,1);
}


void draw_pen_4_1()
{
	draw_pen(4,1);
}

void draw_pen_cross_4_1()
{
	draw_pen_cross(4,1);
}

void draw_pen_cross2_4_1()
{
	draw_pen_cross2(4,1);
}


void draw_pen_8_2()
{
	draw_pen(8,2);
}

void draw_pen_cross_8_2()
{
	draw_pen_cross(8,2);
}

void draw_pen_cross2_8_2()
{
	draw_pen_cross2(8,2);
}


